// Copyright 2021 The OCGI Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	internalinterfaces "github.com/ocgi/carrier/pkg/client/informers/externalversions/internalinterfaces"
)

// Interface provides access to all the informers in this group version.
type Interface interface {
	// GameServers returns a GameServerInformer.
	GameServers() GameServerInformer
	// GameServerSets returns a GameServerSetInformer.
	GameServerSets() GameServerSetInformer
	// Squads returns a SquadInformer.
	Squads() SquadInformer
	// WebhookConfigurations returns a WebhookConfigurationInformer.
	WebhookConfigurations() WebhookConfigurationInformer
}

type version struct {
	factory          internalinterfaces.SharedInformerFactory
	namespace        string
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// New returns a new Interface.
func New(f internalinterfaces.SharedInformerFactory, namespace string, tweakListOptions internalinterfaces.TweakListOptionsFunc) Interface {
	return &version{factory: f, namespace: namespace, tweakListOptions: tweakListOptions}
}

// GameServers returns a GameServerInformer.
func (v *version) GameServers() GameServerInformer {
	return &gameServerInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// GameServerSets returns a GameServerSetInformer.
func (v *version) GameServerSets() GameServerSetInformer {
	return &gameServerSetInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// Squads returns a SquadInformer.
func (v *version) Squads() SquadInformer {
	return &squadInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// WebhookConfigurations returns a WebhookConfigurationInformer.
func (v *version) WebhookConfigurations() WebhookConfigurationInformer {
	return &webhookConfigurationInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}
